DROP TABLE IF EXISTS PERF_RS_CONFIG_TEMPLATE;
CREATE TABLE PERF_RS_CONFIG_TEMPLATE
(
  ID_PERF_RS_CONFIG_TEMPLATE INT(11) PRIMARY KEY NOT NULL AUTO_INCREMENT,
  NOME_TEMPLATE VARCHAR(45) NOT NULL,
  CONFIGURAZIONE JSON NOT NULL,
  DATA_CREAZIONE DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL,
  FLAG_ATTIVO BIT(1) DEFAULT b'1' NOT NULL,
  FLAG_DEFAULT BIT(1) DEFAULT b'0' NOT NULL
);
CREATE UNIQUE INDEX ID_PERF_RS_CONFIG_JSON_UNIQUE ON PERF_RS_CONFIG_TEMPLATE (ID_PERF_RS_CONFIG_TEMPLATE);

DROP TABLE IF EXISTS PERF_RS_CONFIG;
CREATE TABLE PERF_RS_CONFIG
(
  ID_PERF_RS_CONFIG BIGINT(20) PRIMARY KEY NOT NULL AUTO_INCREMENT,
  ID_MUSIC_PROVIDER BIGINT(20) NOT NULL,
  ID_PALINSESTO BIGINT(20),
  ID_CONFIGURATION INT(11),
  VALID_FROM DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL,
  VALID_TO DATETIME,
  CREATION_DATE DATETIME,
  CREATION_USER VARCHAR(50),
  MODIFY_DATE DATETIME,
  MODIFY_USER VARCHAR(50),
  CONSTRAINT FK_CONFIG_MUS_PROVIDER FOREIGN KEY (ID_MUSIC_PROVIDER) REFERENCES PERF_MUSIC_PROVIDER (ID_MUSIC_PROVIDER),
  CONSTRAINT FK_CONFIG_PALINSESTO FOREIGN KEY (ID_PALINSESTO) REFERENCES PERF_PALINSESTO (ID_PALINSESTO),
  CONSTRAINT FK_CONFIG_PERF_TEMPLATE FOREIGN KEY (ID_CONFIGURATION) REFERENCES PERF_RS_CONFIG_TEMPLATE (ID_PERF_RS_CONFIG_TEMPLATE)
);
CREATE INDEX FK_CONFIG_MUS_PROVIDER ON PERF_RS_CONFIG (ID_MUSIC_PROVIDER);
CREATE INDEX FK_CONFIG_PALINSESTO ON PERF_RS_CONFIG (ID_PALINSESTO);
CREATE INDEX FK_CONFIG_PERF_TEMPLATE ON PERF_RS_CONFIG (ID_CONFIGURATION);

DROP TABLE IF EXISTS PERF_RS_NORMALIZED_FILE;
CREATE TABLE PERF_RS_NORMALIZED_FILE
(
  ID_NORMALIZED_FILE BIGINT(20) PRIMARY KEY NOT NULL AUTO_INCREMENT,
  FILE_NAME TEXT NOT NULL,
  FILE_BUCKET TEXT NOT NULL,
  CREATION_DATE DATE NOT NULL
);


DROP TABLE IF EXISTS PERF_RS_UTILIZATION_NORMALIZED_FILE;
CREATE TABLE PERF_RS_UTILIZATION_NORMALIZED_FILE
(
  ID_PERF_RS_UTI_NORM_FILE BIGINT(20) PRIMARY KEY NOT NULL AUTO_INCREMENT,
  ID_UTILIZATION_FILE BIGINT(20) NOT NULL,
  ID_NORMALIZED_FILE BIGINT(20) NOT NULL,
  CONSTRAINT FK_PERF_RS_NORM_FILE FOREIGN KEY (ID_NORMALIZED_FILE) REFERENCES PERF_RS_NORMALIZED_FILE (ID_NORMALIZED_FILE),
  CONSTRAINT FK_PERF_RS_UTIL_FILE FOREIGN KEY (ID_UTILIZATION_FILE) REFERENCES PERF_RS_UTILIZATION_FILE (id)
);
CREATE INDEX FK_PERF_RS_NORM_FILE ON PERF_RS_UTILIZATION_NORMALIZED_FILE (ID_NORMALIZED_FILE);
CREATE INDEX FK_PERF_RS_UTIL_FILE ON PERF_RS_UTILIZATION_NORMALIZED_FILE (ID_UTILIZATION_FILE);


create table if not exists MUSIC_TYPE
(
  ID_MUSIC_TYPE BIGINT(20) PRIMARY KEY NOT NULL AUTO_INCREMENT,
  CATEGORY varchar(200),
  NAME varchar(200)
)
  comment 'Tabella di decodifica delle categorie musicali rappresentate nel formato armonizzato';


create table DECODE_MUSIC_TYPE
(
  ID_DECODE_MUSIC_TYPE BIGINT(20) PRIMARY KEY NOT NULL AUTO_INCREMENT,
  ID_MUSIC_TYPE BIGINT(20) not null,
  ID_CUSTOMER BIGINT(20) null,
  VALUE varchar(200) not null,
  SCOPE varchar(5) not null,
  constraint FK_DECODE_MUS_TYPE foreign key (ID_MUSIC_TYPE) references MUSIC_TYPE (ID_MUSIC_TYPE)
)
  comment 'Tabella corrispondenza tra categorie musicali presenti nei file originali e rappresentate nel formato armonizzato';

create index FK_DECODE_MUSIC_TYPE on DECODE_MUSIC_TYPE (ID_CUSTOMER);

COMMIT;

